VERSION 5.00
Begin VB.Form frmDrawOnDesktop 
   Caption         =   "Draw On Desktop"
   ClientHeight    =   2070
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7185
   LinkTopic       =   "Form1"
   ScaleHeight     =   2070
   ScaleWidth      =   7185
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picToDraw 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   315
      Left            =   4545
      Picture         =   "DrawOnDesktop.frx":0000
      ScaleHeight     =   21
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   171
      TabIndex        =   3
      Top             =   585
      Width           =   2565
   End
   Begin VB.PictureBox picOffScreen 
      BorderStyle     =   0  'None
      Height          =   555
      Left            =   4590
      ScaleHeight     =   555
      ScaleWidth      =   555
      TabIndex        =   2
      Top             =   1125
      Width           =   555
   End
   Begin VB.CommandButton cmdDrawText 
      Caption         =   "&Draw Text"
      Height          =   420
      Left            =   4725
      TabIndex        =   1
      Top             =   90
      Width           =   1770
   End
   Begin VB.TextBox txtDisplay 
      BeginProperty Font 
         Name            =   "Comic Sans MS"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1725
      Left            =   90
      TabIndex        =   0
      Text            =   "Sample Text"
      Top             =   135
      Width           =   4380
   End
End
Attribute VB_Name = "frmDrawOnDesktop"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type


Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function InvalidateRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT, ByVal bErase As Long) As Long

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Const SRCCOPY = &HCC0020

Private Sub cmdDrawText_Click()
    
    Dim lngDesktopHwnd  As Long     ' the Handle to the Desktop Window
    Dim lngDesktopHdc   As Long     ' The Handle to the Desktop DC
    Dim lngTempCounter  As Long
    
    Dim lngMaskColor    As Long
    
    Dim lngWidth        As Long
    Dim lngHeight       As Long
    Dim lngSrcX         As Long
    Dim lngSrcY         As Long
    
    Dim lReturn         As Long
    Dim picDesktop As StdPicture
    
    
    Dim cDrawText       As clsDrawText
    Dim cPaintEffects   As PaintEffects
    
    Set cDrawText = New clsDrawText
    Set cPaintEffects = New PaintEffects
    
    ' Set the Mask Color
    lngMaskColor = &HC0C0C0
    
    ' Set up the temporay dimension
    lngWidth = picToDraw.ScaleWidth
    lngHeight = picToDraw.ScaleHeight
    lngSrcX = 300
    lngSrcY = 500
'    lngSrcX = (Screen.Width / Screen.TwipsPerPixelX) - picToDraw.ScaleWidth
'    lngSrcY = (Screen.Height / Screen.TwipsPerPixelY) - picToDraw.ScaleHeight
    
    picOffScreen.Width = picToDraw.Width
    picOffScreen.Height = picToDraw.Height
    
    
    ' get the Desktop Window
    lngDesktopHwnd = GetDesktopWindow()
    
    ' Get the Desktop DC
    lngDesktopHdc = GetWindowDC(lngDesktopHwnd)
    
'    lReturn = BitBlt(picOffScreen.hdc, 0, 0, lngWidth, lngHeight, _
                    lngDesktopHdc, lngSrcX, lngSrcY, SRCCOPY)
    
    ' Draw the text on the desktop
'    With cDrawText
'        .hdc = lngDesktopHdc
'        .Left = 0
'        .Top = 0
'        .Bottom = 400
'        .Right = 400
'        .Text = txtDisplay.Text
'        Set .Font = txtDisplay.Font
'        .DrawText
'    End With

    ' Draw the Embossed image
    cPaintEffects.PaintDisabledDC picOffScreen.hdc, 0, 0, _
        picToDraw.ScaleWidth, picToDraw.ScaleHeight, _
        picToDraw.hdc, 0, 0
        
    ' Now draw the embossed image to the desktop
    cPaintEffects.PaintTransparentDC lngDesktopHdc, lngSrcX, lngSrcY, _
        picToDraw.ScaleWidth, picToDraw.ScaleHeight, picOffScreen.hdc, _
        0, 0, lngMaskColor
   
    
    ' Clean everything up
    Call ReleaseDC(lngDesktopHwnd, lngDesktopHdc)
    Set cDrawText = Nothing
    Set cPaintEffects = Nothing
    
End Sub


